library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity default is
    Port ( in_val : in std_logic_vector(3 downto 0);
           in_str : in std_logic;
           default_val : in std_logic_vector(3 downto 0);
           default_str : in std_logic;
			  out_val : out std_logic_vector(3 downto 0);
           out_str : out std_logic);
end default;

architecture behavioral of default is

begin

out_str <= in_str or default_str;

process(in_str,in_val,default_val)
begin

if (in_str = '1') then  out_val <= in_val; else
								out_val <= default_val;
end if;

end process;

end behavioral;
