library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity retard is
    Port ( Clk								: IN std_logic;
			  ResetCircuit				   : IN std_logic;
			  Init							: IN std_logic_vector(3 downto 0);
	 		  in_val : in std_logic_vector(3 downto 0);
           in_str : in std_logic;
           out_val : out std_logic_vector(3 downto 0);
           out_str : out std_logic);
end retard;

architecture behavioral of retard is


signal tmp_val : std_logic_vector(3 downto 0);

begin

out_str <= in_str;
out_val <= tmp_val;

process(Clk, ResetCircuit, Init)
	begin

-- si on recoit le signal resetcircuit alors le registre
-- est charge a la valeur init

		if (ResetCircuit = '1') then tmp_val <= Init ; else

-- si on recoit un front d'horloge montant alors 
-- 	si in_str est actif, on stocke in_val dans le regsitre
--		sinon on garde l'ancienne valeur tmp_val du registre

			if (Clk'event and Clk = '1') then
				if ((in_str = '1')) 	then 
				tmp_val <= in_val;
											else
				tmp_val <= tmp_val;
				end if;
			 end if;
		end if;
	end process;
end behavioral;
