library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- cet operateur permet de realiser l'incrementation 
-- d'un nombre code sur 4 bits

entity ass is
    Port ( in_val : in std_logic_vector(3 downto 0);
           in_str : in std_logic;
           out_val : out std_logic_vector(3 downto 0);
           out_str : out std_logic);
end ass;

architecture behavioral of ass is

begin

out_str <= in_str;

process(in_val)
	begin

-- le case en VHDL possede la meme fonctionnalite
-- que le case en C

		case in_val is 
			when "0000" 	=> out_val <= "0001";
			when "0001" 	=> out_val <= "0010";
			when "0010"		=> out_val <= "0011";
			when "0011"		=> out_val <= "0100";
			when "0100"		=> out_val <= "0101";
			when "0101" 	=> out_val <= "0110";
			when "0110" 	=> out_val <= "0111";
			when "0111" 	=> out_val <= "1000";
			when "1000" 	=> out_val <= "1001";
			when others 	=> out_val <= "0000";
		end case;
	 end process;


end behavioral;
